<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRecipeClient2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfRecipeClient2 extends AbstractStructArrayBase
{
    /**
     * The RecipeClient2
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RecipeClient2[]
     */
    public $RecipeClient2;
    /**
     * Constructor method for ArrayOfRecipeClient2
     * @uses ArrayOfRecipeClient2::setRecipeClient2()
     * @param \StructType\RecipeClient2[] $recipeClient2
     */
    public function __construct(array $recipeClient2 = array())
    {
        $this
            ->setRecipeClient2($recipeClient2);
    }
    /**
     * Get RecipeClient2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RecipeClient2[]|null
     */
    public function getRecipeClient2()
    {
        return isset($this->RecipeClient2) ? $this->RecipeClient2 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRecipeClient2 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRecipeClient2 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRecipeClient2ForArrayConstraintsFromSetRecipeClient2(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRecipeClient2RecipeClient2Item) {
            // validation for constraint: itemType
            if (!$arrayOfRecipeClient2RecipeClient2Item instanceof \StructType\RecipeClient2) {
                $invalidValues[] = is_object($arrayOfRecipeClient2RecipeClient2Item) ? get_class($arrayOfRecipeClient2RecipeClient2Item) : sprintf('%s(%s)', gettype($arrayOfRecipeClient2RecipeClient2Item), var_export($arrayOfRecipeClient2RecipeClient2Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RecipeClient2 property can only contain items of type \StructType\RecipeClient2, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RecipeClient2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RecipeClient2[] $recipeClient2
     * @return \ArrayType\ArrayOfRecipeClient2
     */
    public function setRecipeClient2(array $recipeClient2 = array())
    {
        // validation for constraint: array
        if ('' !== ($recipeClient2ArrayErrorMessage = self::validateRecipeClient2ForArrayConstraintsFromSetRecipeClient2($recipeClient2))) {
            throw new \InvalidArgumentException($recipeClient2ArrayErrorMessage, __LINE__);
        }
        if (is_null($recipeClient2) || (is_array($recipeClient2) && empty($recipeClient2))) {
            unset($this->RecipeClient2);
        } else {
            $this->RecipeClient2 = $recipeClient2;
        }
        return $this;
    }
    /**
     * Add item to RecipeClient2 value
     * @throws \InvalidArgumentException
     * @param \StructType\RecipeClient2 $item
     * @return \ArrayType\ArrayOfRecipeClient2
     */
    public function addToRecipeClient2(\StructType\RecipeClient2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RecipeClient2) {
            throw new \InvalidArgumentException(sprintf('The RecipeClient2 property can only contain items of type \StructType\RecipeClient2, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RecipeClient2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RecipeClient2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RecipeClient2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RecipeClient2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RecipeClient2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RecipeClient2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RecipeClient2
     */
    public function getAttributeName()
    {
        return 'RecipeClient2';
    }
}
