<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRecipeClient2Out ArrayType
 * @subpackage Arrays
 */
class ArrayOfRecipeClient2Out extends AbstractStructArrayBase
{
    /**
     * The RecipeClient2Out
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RecipeClient2Out[]
     */
    public $RecipeClient2Out;
    /**
     * Constructor method for ArrayOfRecipeClient2Out
     * @uses ArrayOfRecipeClient2Out::setRecipeClient2Out()
     * @param \StructType\RecipeClient2Out[] $recipeClient2Out
     */
    public function __construct(array $recipeClient2Out = array())
    {
        $this
            ->setRecipeClient2Out($recipeClient2Out);
    }
    /**
     * Get RecipeClient2Out value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RecipeClient2Out[]|null
     */
    public function getRecipeClient2Out()
    {
        return isset($this->RecipeClient2Out) ? $this->RecipeClient2Out : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRecipeClient2Out method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRecipeClient2Out method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRecipeClient2OutForArrayConstraintsFromSetRecipeClient2Out(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRecipeClient2OutRecipeClient2OutItem) {
            // validation for constraint: itemType
            if (!$arrayOfRecipeClient2OutRecipeClient2OutItem instanceof \StructType\RecipeClient2Out) {
                $invalidValues[] = is_object($arrayOfRecipeClient2OutRecipeClient2OutItem) ? get_class($arrayOfRecipeClient2OutRecipeClient2OutItem) : sprintf('%s(%s)', gettype($arrayOfRecipeClient2OutRecipeClient2OutItem), var_export($arrayOfRecipeClient2OutRecipeClient2OutItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RecipeClient2Out property can only contain items of type \StructType\RecipeClient2Out, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RecipeClient2Out value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RecipeClient2Out[] $recipeClient2Out
     * @return \ArrayType\ArrayOfRecipeClient2Out
     */
    public function setRecipeClient2Out(array $recipeClient2Out = array())
    {
        // validation for constraint: array
        if ('' !== ($recipeClient2OutArrayErrorMessage = self::validateRecipeClient2OutForArrayConstraintsFromSetRecipeClient2Out($recipeClient2Out))) {
            throw new \InvalidArgumentException($recipeClient2OutArrayErrorMessage, __LINE__);
        }
        if (is_null($recipeClient2Out) || (is_array($recipeClient2Out) && empty($recipeClient2Out))) {
            unset($this->RecipeClient2Out);
        } else {
            $this->RecipeClient2Out = $recipeClient2Out;
        }
        return $this;
    }
    /**
     * Add item to RecipeClient2Out value
     * @throws \InvalidArgumentException
     * @param \StructType\RecipeClient2Out $item
     * @return \ArrayType\ArrayOfRecipeClient2Out
     */
    public function addToRecipeClient2Out(\StructType\RecipeClient2Out $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RecipeClient2Out) {
            throw new \InvalidArgumentException(sprintf('The RecipeClient2Out property can only contain items of type \StructType\RecipeClient2Out, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RecipeClient2Out[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RecipeClient2Out|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RecipeClient2Out|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RecipeClient2Out|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RecipeClient2Out|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RecipeClient2Out|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RecipeClient2Out
     */
    public function getAttributeName()
    {
        return 'RecipeClient2Out';
    }
}
