<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRecipeReestr ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRecipeReestr
 * @subpackage Arrays
 */
class ArrayOfRecipeReestr extends AbstractStructArrayBase
{
    /**
     * The RecipeReestr
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RecipeReestr[]
     */
    public $RecipeReestr;
    /**
     * Constructor method for ArrayOfRecipeReestr
     * @uses ArrayOfRecipeReestr::setRecipeReestr()
     * @param \StructType\RecipeReestr[] $recipeReestr
     */
    public function __construct(array $recipeReestr = array())
    {
        $this
            ->setRecipeReestr($recipeReestr);
    }
    /**
     * Get RecipeReestr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RecipeReestr[]|null
     */
    public function getRecipeReestr()
    {
        return isset($this->RecipeReestr) ? $this->RecipeReestr : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRecipeReestr method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRecipeReestr method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRecipeReestrForArrayConstraintsFromSetRecipeReestr(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRecipeReestrRecipeReestrItem) {
            // validation for constraint: itemType
            if (!$arrayOfRecipeReestrRecipeReestrItem instanceof \StructType\RecipeReestr) {
                $invalidValues[] = is_object($arrayOfRecipeReestrRecipeReestrItem) ? get_class($arrayOfRecipeReestrRecipeReestrItem) : sprintf('%s(%s)', gettype($arrayOfRecipeReestrRecipeReestrItem), var_export($arrayOfRecipeReestrRecipeReestrItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RecipeReestr property can only contain items of type \StructType\RecipeReestr, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RecipeReestr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RecipeReestr[] $recipeReestr
     * @return \ArrayType\ArrayOfRecipeReestr
     */
    public function setRecipeReestr(array $recipeReestr = array())
    {
        // validation for constraint: array
        if ('' !== ($recipeReestrArrayErrorMessage = self::validateRecipeReestrForArrayConstraintsFromSetRecipeReestr($recipeReestr))) {
            throw new \InvalidArgumentException($recipeReestrArrayErrorMessage, __LINE__);
        }
        if (is_null($recipeReestr) || (is_array($recipeReestr) && empty($recipeReestr))) {
            unset($this->RecipeReestr);
        } else {
            $this->RecipeReestr = $recipeReestr;
        }
        return $this;
    }
    /**
     * Add item to RecipeReestr value
     * @throws \InvalidArgumentException
     * @param \StructType\RecipeReestr $item
     * @return \ArrayType\ArrayOfRecipeReestr
     */
    public function addToRecipeReestr(\StructType\RecipeReestr $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RecipeReestr) {
            throw new \InvalidArgumentException(sprintf('The RecipeReestr property can only contain items of type \StructType\RecipeReestr, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RecipeReestr[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RecipeReestr|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RecipeReestr|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RecipeReestr|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RecipeReestr|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RecipeReestr|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RecipeReestr
     */
    public function getAttributeName()
    {
        return 'RecipeReestr';
    }
}
