<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'RecipeRequest' => '\\StructType\\RecipeRequest',
            'RecipeRequestResponse' => '\\StructType\\RecipeRequestResponse',
            'ArrayOfRecipe' => '\\ArrayType\\ArrayOfRecipe',
            'Recipe' => '\\StructType\\Recipe',
            'Entity' => '\\StructType\\Entity',
            'MnnItem' => '\\StructType\\MnnItem',
            'RecipeReserveInfo' => '\\StructType\\RecipeReserveInfo',
            'ArrayOfRecipeReserveInfo' => '\\ArrayType\\ArrayOfRecipeReserveInfo',
            'ArrayOfMnnItem' => '\\ArrayType\\ArrayOfMnnItem',
            'RecipeRequest2' => '\\StructType\\RecipeRequest2',
            'RecipeRequest2Response' => '\\StructType\\RecipeRequest2Response',
            'LpuRecipeRequest' => '\\StructType\\LpuRecipeRequest',
            'LpuRecipeRequestResponse' => '\\StructType\\LpuRecipeRequestResponse',
            'ArrayOfLpuRecipe' => '\\ArrayType\\ArrayOfLpuRecipe',
            'LpuRecipe' => '\\StructType\\LpuRecipe',
            'LpuRecipePdfData' => '\\StructType\\LpuRecipePdfData',
            'LpuRecipeSignatureData' => '\\StructType\\LpuRecipeSignatureData',
            'RecipeRequestRepeat' => '\\StructType\\RecipeRequestRepeat',
            'RecipeRequestRepeatResponse' => '\\StructType\\RecipeRequestRepeatResponse',
            'RecipeResponse' => '\\StructType\\RecipeResponse',
            'ArrayOfRecipeResponseInfo' => '\\ArrayType\\ArrayOfRecipeResponseInfo',
            'RecipeResponseInfo' => '\\StructType\\RecipeResponseInfo',
            'RecipeResponseResponse' => '\\StructType\\RecipeResponseResponse',
            'RecipeResponseInfoOut' => '\\StructType\\RecipeResponseInfoOut',
            'RecipeFind' => '\\StructType\\RecipeFind',
            'RecipeFindResponse' => '\\StructType\\RecipeFindResponse',
            'RecipeCheck' => '\\StructType\\RecipeCheck',
            'RecipeCheckResponse' => '\\StructType\\RecipeCheckResponse',
            'RecipeEditCheck' => '\\StructType\\RecipeEditCheck',
            'RecipeEditCheckResponse' => '\\StructType\\RecipeEditCheckResponse',
            'RecipeDelay' => '\\StructType\\RecipeDelay',
            'RecipeDelayResponse' => '\\StructType\\RecipeDelayResponse',
            'RecipeClientSave' => '\\StructType\\RecipeClientSave',
            'RecipeClient' => '\\StructType\\RecipeClient',
            'RecipeClientSaveResponse' => '\\StructType\\RecipeClientSaveResponse',
            'RecipesClientSave' => '\\StructType\\RecipesClientSave',
            'ArrayOfRecipeClient' => '\\ArrayType\\ArrayOfRecipeClient',
            'RecipesClientSaveResponse' => '\\StructType\\RecipesClientSaveResponse',
            'RecipesClient2Save' => '\\StructType\\RecipesClient2Save',
            'ArrayOfRecipeClient2' => '\\ArrayType\\ArrayOfRecipeClient2',
            'RecipeClient2' => '\\StructType\\RecipeClient2',
            'RecipeClient2Issue' => '\\StructType\\RecipeClient2Issue',
            'RecipeClient2Sale' => '\\StructType\\RecipeClient2Sale',
            'ArrayOfItem' => '\\ArrayType\\ArrayOfItem',
            'Item' => '\\StructType\\Item',
            'RecipesClient2SaveResponse' => '\\StructType\\RecipesClient2SaveResponse',
            'ArrayOfRecipeClient2Out' => '\\ArrayType\\ArrayOfRecipeClient2Out',
            'RecipeClient2Out' => '\\StructType\\RecipeClient2Out',
            'RecipeReestrRequest' => '\\StructType\\RecipeReestrRequest',
            'RecipeReestrRequestResponse' => '\\StructType\\RecipeReestrRequestResponse',
            'ArrayOfRecipeReestr' => '\\ArrayType\\ArrayOfRecipeReestr',
            'RecipeReestr' => '\\StructType\\RecipeReestr',
            'RecipesClientHashesExchange' => '\\StructType\\RecipesClientHashesExchange',
            'ArrayOfDocumentHash' => '\\ArrayType\\ArrayOfDocumentHash',
            'DocumentHash' => '\\StructType\\DocumentHash',
            'RecipesClientHashesExchangeResponse' => '\\StructType\\RecipesClientHashesExchangeResponse',
        );
    }
}
