<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LpuRecipeRequest StructType
 * @subpackage Structs
 */
class LpuRecipeRequest extends Entity
{
    /**
     * The clientId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $clientId;
    /**
     * The param
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\LpuRecipeRequest
     */
    public $param;
    /**
     * The Snils
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Snils;
    /**
     * The Credential
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Credential;
    /**
     * The DateFrom
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DateFrom;
    /**
     * The DateTo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DateTo;
    /**
     * Constructor method for LpuRecipeRequest
     * @uses LpuRecipeRequest::setClientId()
     * @uses LpuRecipeRequest::setParam()
     * @uses LpuRecipeRequest::setSnils()
     * @uses LpuRecipeRequest::setCredential()
     * @uses LpuRecipeRequest::setDateFrom()
     * @uses LpuRecipeRequest::setDateTo()
     * @param string $clientId
     * @param \StructType\LpuRecipeRequest $param
     * @param string $snils
     * @param string $credential
     * @param string $dateFrom
     * @param string $dateTo
     */
    public function __construct($clientId = null, \StructType\LpuRecipeRequest $param = null, $snils = null, $credential = null, $dateFrom = null, $dateTo = null)
    {
        $this
            ->setClientId($clientId)
            ->setParam($param)
            ->setSnils($snils)
            ->setCredential($credential)
            ->setDateFrom($dateFrom)
            ->setDateTo($dateTo);
    }
    /**
     * Get clientId value
     * @return string|null
     */
    public function getClientId()
    {
        return $this->clientId;
    }
    /**
     * Set clientId value
     * @param string $clientId
     * @return \StructType\LpuRecipeRequest
     */
    public function setClientId($clientId = null)
    {
        // validation for constraint: string
        if (!is_null($clientId) && !is_string($clientId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($clientId, true), gettype($clientId)), __LINE__);
        }
        $this->clientId = $clientId;
        return $this;
    }
    /**
     * Get param value
     * @return \StructType\LpuRecipeRequest|null
     */
    public function getParam()
    {
        return $this->param;
    }
    /**
     * Set param value
     * @param \StructType\LpuRecipeRequest $param
     * @return \StructType\LpuRecipeRequest
     */
    public function setParam(\StructType\LpuRecipeRequest $param = null)
    {
        $this->param = $param;
        return $this;
    }
    /**
     * Get Snils value
     * @return string|null
     */
    public function getSnils()
    {
        return $this->Snils;
    }
    /**
     * Set Snils value
     * @param string $snils
     * @return \StructType\LpuRecipeRequest
     */
    public function setSnils($snils = null)
    {
        // validation for constraint: string
        if (!is_null($snils) && !is_string($snils)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($snils, true), gettype($snils)), __LINE__);
        }
        $this->Snils = $snils;
        return $this;
    }
    /**
     * Get Credential value
     * @return string|null
     */
    public function getCredential()
    {
        return $this->Credential;
    }
    /**
     * Set Credential value
     * @param string $credential
     * @return \StructType\LpuRecipeRequest
     */
    public function setCredential($credential = null)
    {
        // validation for constraint: string
        if (!is_null($credential) && !is_string($credential)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($credential, true), gettype($credential)), __LINE__);
        }
        $this->Credential = $credential;
        return $this;
    }
    /**
     * Get DateFrom value
     * @return string|null
     */
    public function getDateFrom()
    {
        return $this->DateFrom;
    }
    /**
     * Set DateFrom value
     * @param string $dateFrom
     * @return \StructType\LpuRecipeRequest
     */
    public function setDateFrom($dateFrom = null)
    {
        // validation for constraint: string
        if (!is_null($dateFrom) && !is_string($dateFrom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dateFrom, true), gettype($dateFrom)), __LINE__);
        }
        $this->DateFrom = $dateFrom;
        return $this;
    }
    /**
     * Get DateTo value
     * @return string|null
     */
    public function getDateTo()
    {
        return $this->DateTo;
    }
    /**
     * Set DateTo value
     * @param string $dateTo
     * @return \StructType\LpuRecipeRequest
     */
    public function setDateTo($dateTo = null)
    {
        // validation for constraint: string
        if (!is_null($dateTo) && !is_string($dateTo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dateTo, true), gettype($dateTo)), __LINE__);
        }
        $this->DateTo = $dateTo;
        return $this;
    }
}
