<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MnnItem StructType
 * @subpackage Structs
 */
class MnnItem extends Entity
{
    /**
     * The Seria
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Seria;
    /**
     * The Number
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Number;
    /**
     * The Id
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Id;
    /**
     * The MnnId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MnnId;
    /**
     * The MnnName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MnnName;
    /**
     * The Code
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Code;
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The NameLat
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $NameLat;
    /**
     * The Note
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Note;
    /**
     * The RecipeId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $RecipeId;
    /**
     * Constructor method for MnnItem
     * @uses MnnItem::setSeria()
     * @uses MnnItem::setNumber()
     * @uses MnnItem::setId()
     * @uses MnnItem::setMnnId()
     * @uses MnnItem::setMnnName()
     * @uses MnnItem::setCode()
     * @uses MnnItem::setName()
     * @uses MnnItem::setNameLat()
     * @uses MnnItem::setNote()
     * @uses MnnItem::setRecipeId()
     * @param string $seria
     * @param string $number
     * @param string $id
     * @param string $mnnId
     * @param string $mnnName
     * @param string $code
     * @param string $name
     * @param string $nameLat
     * @param string $note
     * @param string $recipeId
     */
    public function __construct($seria = null, $number = null, $id = null, $mnnId = null, $mnnName = null, $code = null, $name = null, $nameLat = null, $note = null, $recipeId = null)
    {
        $this
            ->setSeria($seria)
            ->setNumber($number)
            ->setId($id)
            ->setMnnId($mnnId)
            ->setMnnName($mnnName)
            ->setCode($code)
            ->setName($name)
            ->setNameLat($nameLat)
            ->setNote($note)
            ->setRecipeId($recipeId);
    }
    /**
     * Get Seria value
     * @return string|null
     */
    public function getSeria()
    {
        return $this->Seria;
    }
    /**
     * Set Seria value
     * @param string $seria
     * @return \StructType\MnnItem
     */
    public function setSeria($seria = null)
    {
        // validation for constraint: string
        if (!is_null($seria) && !is_string($seria)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($seria, true), gettype($seria)), __LINE__);
        }
        $this->Seria = $seria;
        return $this;
    }
    /**
     * Get Number value
     * @return string|null
     */
    public function getNumber()
    {
        return $this->Number;
    }
    /**
     * Set Number value
     * @param string $number
     * @return \StructType\MnnItem
     */
    public function setNumber($number = null)
    {
        // validation for constraint: string
        if (!is_null($number) && !is_string($number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($number, true), gettype($number)), __LINE__);
        }
        $this->Number = $number;
        return $this;
    }
    /**
     * Get Id value
     * @return string|null
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param string $id
     * @return \StructType\MnnItem
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Get MnnId value
     * @return string|null
     */
    public function getMnnId()
    {
        return $this->MnnId;
    }
    /**
     * Set MnnId value
     * @param string $mnnId
     * @return \StructType\MnnItem
     */
    public function setMnnId($mnnId = null)
    {
        // validation for constraint: string
        if (!is_null($mnnId) && !is_string($mnnId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mnnId, true), gettype($mnnId)), __LINE__);
        }
        $this->MnnId = $mnnId;
        return $this;
    }
    /**
     * Get MnnName value
     * @return string|null
     */
    public function getMnnName()
    {
        return $this->MnnName;
    }
    /**
     * Set MnnName value
     * @param string $mnnName
     * @return \StructType\MnnItem
     */
    public function setMnnName($mnnName = null)
    {
        // validation for constraint: string
        if (!is_null($mnnName) && !is_string($mnnName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mnnName, true), gettype($mnnName)), __LINE__);
        }
        $this->MnnName = $mnnName;
        return $this;
    }
    /**
     * Get Code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param string $code
     * @return \StructType\MnnItem
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        $this->Code = $code;
        return $this;
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\MnnItem
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get NameLat value
     * @return string|null
     */
    public function getNameLat()
    {
        return $this->NameLat;
    }
    /**
     * Set NameLat value
     * @param string $nameLat
     * @return \StructType\MnnItem
     */
    public function setNameLat($nameLat = null)
    {
        // validation for constraint: string
        if (!is_null($nameLat) && !is_string($nameLat)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nameLat, true), gettype($nameLat)), __LINE__);
        }
        $this->NameLat = $nameLat;
        return $this;
    }
    /**
     * Get Note value
     * @return string|null
     */
    public function getNote()
    {
        return $this->Note;
    }
    /**
     * Set Note value
     * @param string $note
     * @return \StructType\MnnItem
     */
    public function setNote($note = null)
    {
        // validation for constraint: string
        if (!is_null($note) && !is_string($note)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($note, true), gettype($note)), __LINE__);
        }
        $this->Note = $note;
        return $this;
    }
    /**
     * Get RecipeId value
     * @return string|null
     */
    public function getRecipeId()
    {
        return $this->RecipeId;
    }
    /**
     * Set RecipeId value
     * @param string $recipeId
     * @return \StructType\MnnItem
     */
    public function setRecipeId($recipeId = null)
    {
        // validation for constraint: string
        if (!is_null($recipeId) && !is_string($recipeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($recipeId, true), gettype($recipeId)), __LINE__);
        }
        $this->RecipeId = $recipeId;
        return $this;
    }
}
