<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RecipeRequest2 StructType
 * @subpackage Structs
 */
class RecipeRequest2 extends Entity
{
    /**
     * The ShowExpired
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $ShowExpired;
    /**
     * The clientId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $clientId;
    /**
     * The param
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\RecipeRequest2
     */
    public $param;
    /**
     * The Snils
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Snils;
    /**
     * The Credential
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Credential;
    /**
     * Constructor method for RecipeRequest2
     * @uses RecipeRequest2::setShowExpired()
     * @uses RecipeRequest2::setClientId()
     * @uses RecipeRequest2::setParam()
     * @uses RecipeRequest2::setSnils()
     * @uses RecipeRequest2::setCredential()
     * @param bool $showExpired
     * @param string $clientId
     * @param \StructType\RecipeRequest2 $param
     * @param string $snils
     * @param string $credential
     */
    public function __construct($showExpired = null, $clientId = null, \StructType\RecipeRequest2 $param = null, $snils = null, $credential = null)
    {
        $this
            ->setShowExpired($showExpired)
            ->setClientId($clientId)
            ->setParam($param)
            ->setSnils($snils)
            ->setCredential($credential);
    }
    /**
     * Get ShowExpired value
     * @return bool
     */
    public function getShowExpired()
    {
        return $this->ShowExpired;
    }
    /**
     * Set ShowExpired value
     * @param bool $showExpired
     * @return \StructType\RecipeRequest2
     */
    public function setShowExpired($showExpired = null)
    {
        // validation for constraint: boolean
        if (!is_null($showExpired) && !is_bool($showExpired)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($showExpired, true), gettype($showExpired)), __LINE__);
        }
        $this->ShowExpired = $showExpired;
        return $this;
    }
    /**
     * Get clientId value
     * @return string|null
     */
    public function getClientId()
    {
        return $this->clientId;
    }
    /**
     * Set clientId value
     * @param string $clientId
     * @return \StructType\RecipeRequest2
     */
    public function setClientId($clientId = null)
    {
        // validation for constraint: string
        if (!is_null($clientId) && !is_string($clientId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($clientId, true), gettype($clientId)), __LINE__);
        }
        $this->clientId = $clientId;
        return $this;
    }
    /**
     * Get param value
     * @return \StructType\RecipeRequest2|null
     */
    public function getParam()
    {
        return $this->param;
    }
    /**
     * Set param value
     * @param \StructType\RecipeRequest2 $param
     * @return \StructType\RecipeRequest2
     */
    public function setParam(\StructType\RecipeRequest2 $param = null)
    {
        $this->param = $param;
        return $this;
    }
    /**
     * Get Snils value
     * @return string|null
     */
    public function getSnils()
    {
        return $this->Snils;
    }
    /**
     * Set Snils value
     * @param string $snils
     * @return \StructType\RecipeRequest2
     */
    public function setSnils($snils = null)
    {
        // validation for constraint: string
        if (!is_null($snils) && !is_string($snils)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($snils, true), gettype($snils)), __LINE__);
        }
        $this->Snils = $snils;
        return $this;
    }
    /**
     * Get Credential value
     * @return string|null
     */
    public function getCredential()
    {
        return $this->Credential;
    }
    /**
     * Set Credential value
     * @param string $credential
     * @return \StructType\RecipeRequest2
     */
    public function setCredential($credential = null)
    {
        // validation for constraint: string
        if (!is_null($credential) && !is_string($credential)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($credential, true), gettype($credential)), __LINE__);
        }
        $this->Credential = $credential;
        return $this;
    }
}
